Option Explicit On
Option Strict On

Imports OpenCVLib
Imports System.drawing
Imports System.Runtime.InteropServices


'//////////////////////////////////////////////////////////
'OpenCV[eBeBW[
''' <summary>
''' OpenCVgꍇɕ֗Ȋ֐`Z߂W[łB
''' </summary>
''' <remarks></remarks>
Public Module CvUtility

    '//////////////////////////////////////////////////////////

#Region "g^`"

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi, Pack:=4)> _
    Public Structure CuLine
        Public p1 As CvPoint
        Public p2 As CvPoint
    End Structure


#End Region

    '//////////////////////////////////////////////////////////

#Region "ėpAPI`"

    Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest As IntPtr, ByVal hpvSource As IntPtr, ByVal Count As Integer)
    Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As IntPtr
    Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As IntPtr) As Integer
    Public Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As IntPtr, ByVal lpFileName As String, ByVal nSize As Integer) As Integer

#End Region

    '//////////////////////////////////////////////////////////

#Region "/|C^֘A"

    ''' <summary>
    ''' A}l[Ẅ̃f[^}l[ẄɃRs[܂B
    ''' ̊֐̓f[^^ϊȗׂ̊֐łB
    ''' </summary>
    ''' <typeparam name="T">f[^^(l^̂)</typeparam>
    ''' <param name="Ptr">A}l[Ẅ̃|C^</param>
    ''' <returns>\̃f[^</returns>
    ''' <remarks></remarks>
    Public Function PtrToStructure(Of T As Structure)(ByVal Ptr As IntPtr) As T
        Return CType(Marshal.PtrToStructure(Ptr, GetType(T)), T)
    End Function
    Public Function PtrToStructure(Of T)(ByVal Ptr As IntPtr, ByVal Offset As Integer) As T
        Dim pp As IntPtr = CType(Ptr.ToInt32 + Offset, IntPtr)
        Return CType(Marshal.PtrToStructure(pp, GetType(T)), T)
    End Function

    ''' <summary>
    ''' }l[Ẅ̃f[^(\̃f[^)A}l[ẄɃRs[܂B
    ''' </summary>
    ''' <typeparam name="T">f[^^(l^̂)</typeparam>
    ''' <param name="Data">Rs[̍\̃f[^</param>
    ''' <param name="Ptr">A}l[Ẅ̃|C^</param>
    ''' <remarks></remarks>
    Public Sub StructureToPtr(Of T As Structure)(ByVal Data As T, ByVal Ptr As IntPtr)
        Marshal.StructureToPtr(Data, Ptr, False)
    End Sub

    ''' <summary>
    ''' A}l[ẄɃmۂ܂B
    ''' </summary>
    ''' <typeparam name="T">f[^^</typeparam>
    ''' <param name="Count">f[^(oCgł͂܂)</param>
    ''' <returns>mۂA}l[Ẅւ̃|C^</returns>
    ''' <remarks>mۂoCǵAuf[^^̃TCYv~uf[^vƂȂ܂B</remarks>
    Public Function Alloc(Of T)(Optional ByVal Count As Integer = 1) As IntPtr

        'ꌏ̃TCY擾
        Dim sz As Integer
        sz = Marshal.SizeOf(GetType(T))

        '̈m
        Dim ptr As IntPtr
        ptr = Marshal.AllocHGlobal(sz * Count)

        Return ptr
    End Function

    ''' <summary>
    ''' AllocŊmۂ̈J܂B
    ''' </summary>
    ''' <param name="Ptr">A}l[Ẅւ̃|C^</param>
    ''' <remarks></remarks>
    Public Sub Free(ByVal Ptr As IntPtr)
        If Ptr <> IntPtr.Zero Then
            Marshal.FreeHGlobal(Ptr)
        End If
    End Sub

#End Region

#Region "֘A"

    'DLL̃tpX擾
    ''' <summary>
    ''' DLL̃tpX擾܂B
    ''' DLL̂ȗꍇAOpenCṼCXg[tH_擾܂B
    ''' </summary>
    ''' <param name="DllName">DLL(pXȂÁA΃pXDLLt@C)</param>
    ''' <param name="ForceFree">DLLꍇTrueAȂꍇFalse</param>
    ''' <returns>DLLǂݍ݉\ȏꍇDLL̃tpXADLLȂꍇ󕶎</returns>
    ''' <remarks>
    ''' ̊֐OpenCṼTvf[^gꍇɎgp邱Ƃz肵Ă܂B
    ''' DLLp\̏ꍇAw肳ꂽDLL͈UvZXɃ[h(LoadLibrary)܂B
    ''' ForceFreeTruȅꍇApX擾ɉ(FreeLibrary)܂B
    ''' </remarks>
    Public Function GetDLLPath(ByVal DllName As String, Optional ByVal ForceFree As Boolean = False) As String
        Const MAXPATH As Integer = 512

        'DLLǂݍ
        Dim hMod As IntPtr = LoadLibrary(DllName)
        If hMod = IntPtr.Zero Then
            'DLLȂ
            Return ""
        End If

        'tpX擾
        Dim buff As String = New String(Chr(0), MAXPATH)
        GetModuleFileName(hMod, buff, MAXPATH - 1)
        buff = buff.Replace(Chr(0), " ")
        buff = buff.Trim

        'DLL
        If ForceFree Then
            FreeLibrary(hMod)
        End If

        Return buff
    End Function
    ''' <summary>
    ''' OpenCṼCXg[tH_̃pX擾܂B
    ''' </summary>
    ''' <returns>OpenCṼCXg[tH_pX</returns>
    ''' <remarks>
    ''' DLLp\̏ꍇAuCVxxx.DLLvUvZXɃ[h܂B
    ''' </remarks>
    Public Function GetDLLPath() As String

        Try
            'CVxxx.DLL̃pX擾
            Dim cvpath As String = GetDLLPath(OpenCVInformation.Cv)

            'e̐etH_擾
            Dim pp As New System.IO.FileInfo(cvpath)
            Return pp.Directory.Parent.FullName

        Catch ex As Exception
            's

        End Try

        'Ȃ
        Return ""
    End Function

#End Region

#Region "C[W֘A"

    ''' <summary>
    ''' IplImage|C^C[Wf[^}l[ẄɃRs[܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>IplImage\</returns>
    ''' <remarks>
    ''' ߂l̓|C^C[Wf[^̃Rs[łB
    ''' QƂ͖肠܂񂪁AXVꍇӂĉB
    ''' A}l[ẄXVꍇ́ARs[XVA
    ''' Marshal.StructureToPtr( img, ImagePtr, False )
    ''' ̏sKv܂B
    ''' </remarks>
    Public Function GetIplImage(ByVal ImagePtr As IntPtr) As IplImage
        Return CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
    End Function

    ''' <summary>
    ''' IplImage|C^C[W̃TCY擾܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>C[W̑傫(CvSize^)</returns>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Function GetIplImageSize(ByVal ImagePtr As IntPtr) As CvSize
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        Return New CvSize(img.width, img.height)
    End Function

    ''' <summary>
    ''' IplImage|C^C[W̃f[^i[擾܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>f[^i[ 0:Top-Down 1:Bottom-Up</returns>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Function GetIplImageOrigin(ByVal ImagePtr As IntPtr) As Integer
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        Return img.origin
    End Function

    ''' <summary>
    ''' IplImage|C^C[W̃f[^i[ݒ肵܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <param name="origin">f[^i[ 0:Top-Down 1:Bottom-Up</param>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Sub SetIplImageOrigin(ByVal ImagePtr As IntPtr, ByVal origin As Integer)
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        img.origin = origin
        Marshal.StructureToPtr(img, ImagePtr, False)
    End Sub

    ''' <summary>
    ''' IplImage|C^C[W̃`l擾܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>`l</returns>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Function GetIplImageChannels(ByVal ImagePtr As IntPtr) As Integer
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        Return img.nChannels
    End Function

    ''' <summary>
    ''' IplImage|C^C[W̃f[^i[̈|C^擾܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>f[^i[̈|C^</returns>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Function GetIplImageDataPtr(ByVal ImagePtr As IntPtr) As IntPtr
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        Return img.imageData
    End Function

#End Region

#Region "\EBhE֘A"

    ''' <summary>
    ''' OpenCV\EBhẼbpNXłB
    ''' </summary>
    ''' <remarks></remarks>
    Public Class CuWindow

        '======================================================
#Region "f[^"

        ''' <summary>EBhÊێ܂B</summary>
        Private mWindowName As String

#End Region

#Region "Win32 API"

        ''' <summary>
        ''' RECT^\̂łB
        ''' </summary>
        ''' <remarks></remarks>
        <StructLayout(LayoutKind.Sequential)> _
        Private Structure APIRECT
            Public Left As Integer
            Public Top As Integer
            Public Right As Integer
            Public Bottom As Integer
        End Structure

        Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hWnd As IntPtr, ByRef Rect As APIRECT) As Integer
        Private Declare Function GetParent Lib "user32.dll" (ByVal hWnd As IntPtr) As IntPtr

#End Region

        '======================================================
#Region "Ej"

        ''' <summary>
        ''' NX܂B
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub New()

        End Sub

        ''' <summary>
        ''' EBhE쐬ANX܂B
        ''' </summary>
        ''' <param name="Name">EBhE</param>
        ''' <remarks></remarks>
        Public Sub New(ByVal Name As String)

            'EBhE쐬A^b`
            Create(Name)

        End Sub

        ''' <summary>
        ''' OpenCVEBhEɃA^b`܂B
        ''' </summary>
        ''' <param name="Name">EBhE</param>
        ''' <remarks></remarks>
        Public Sub Attach(ByVal Name As String)

            '̕ۑ
            mWindowName = Name

        End Sub

#End Region

#Region "EBhE쐬Ej"

        ''' <summary>
        ''' EBhE쐬܂B
        ''' </summary>
        ''' <param name="Name">EBhE(󔒎͎쐬)</param>
        ''' <param name="Flag">tO</param>
        ''' <returns>쐬ꂽEBhE̖</returns>
        ''' <remarks></remarks>
        Public Shared Function CreateWindow(Optional ByVal Name As String = "", Optional ByVal Flag As Integer = CV_WINDOW_AUTOSIZE) As String

            'EBhE
            If Name = "" Then
                Name = System.Environment.TickCount().ToString
            End If

            '쐬
            cvNamedWindow(Name, Flag)

            Return Name
        End Function

        ''' <summary>
        ''' EBhE쐬܂B
        ''' </summary>
        ''' <param name="Name">EBhE(󔒎͎쐬)</param>
        ''' <param name="Flag">tO</param>
        ''' <remarks></remarks>
        Public Sub Create(Optional ByVal Name As String = "", Optional ByVal Flag As Integer = CV_WINDOW_AUTOSIZE)

            '쐬A^b`
            Attach(CreateWindow(Name, Flag))

        End Sub

        ''' <summary>
        ''' EBhEj܂B
        ''' </summary>
        ''' <param name="Name">EBhE</param>
        ''' <remarks></remarks>
        Public Shared Sub DestroyWindow(ByVal Name As String)

            'mF
            If Name = "" Then Exit Sub

            'j
            cvDestroyWindow(Name)

        End Sub

        ''' <summary>
        ''' EBhE܂B
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub Close()

            DestroyWindow(mWindowName)

        End Sub

#End Region

        '------------------------------------------------------
#Region "e擾Eݒ"

        ''' <summary>
        ''' A^b`ĂEBhÊԂ܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property Name() As String
            Get
                'mF
                If mWindowName = "" Then
                    mWindowName = CreateWindow("")
                End If

                Return mWindowName
            End Get
        End Property

        ''' <summary>
        ''' \̈̃EBhEnh(cvGetWindowHandle̒l)Ԃ܂B
        ''' A^b`ĂȂꍇ́AIntPtr.ZeroԂ܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property ClientHandle() As IntPtr
            Get
                If mWindowName = "" Then Return IntPtr.Zero

                Return cvGetWindowHandle(mWindowName)
            End Get
        End Property

        ''' <summary>
        ''' \̈̃TCYݒ肵܂B
        ''' </summary>
        ''' <value></value>
        ''' <remarks></remarks>
        Public WriteOnly Property ClientSize() As Size
            Set(ByVal value As Size)
                SetClientSize(mWindowName, value)
            End Set
        End Property

        ''' <summary>
        ''' gbvxEBhẼnhԂ܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property WindowHandle() As IntPtr
            Get

                'EBhẼnh擾
                Dim hw As IntPtr = Me.ClientHandle
                If hw = IntPtr.Zero Then Return hw

                'eEBhẼnh擾
                Dim phw As IntPtr = GetParent(hw)

                Return phw
            End Get
        End Property

        ''' <summary>
        ''' gbvxEBhËʒuԂ܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property WindowRect() As Rectangle
            Get
                Return GetWindowRect(mWindowName)
            End Get
        End Property

        ''' <summary>
        ''' gbvxEBhËʒu擾Eݒ肵܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property WindowLocate() As Point
            Get
                Return WindowRect.Location
            End Get
            Set(ByVal value As Point)
                SetWindowLocate(mWindowName, value.X, value.Y)
            End Set
        End Property

        ''' <summary>
        ''' gbvxEBhẼTCY擾܂B
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public ReadOnly Property WindowSize() As Size
            Get
                Return Me.WindowRect.Size
            End Get
        End Property

        ''' <summary>
        ''' \̈TCYݒ肵܂B
        ''' </summary>
        ''' <param name="WindowName">EBhE</param>
        ''' <param name="NewSize">TCY</param>
        ''' <remarks></remarks>
        Public Shared Sub SetClientSize(ByVal WindowName As String, ByVal NewSize As Size)

            'mF
            If WindowName = "" Then Exit Sub

            'ݒ
            cvResizeWindow(WindowName, NewSize.Width, NewSize.Height)

        End Sub

        ''' <summary>
        ''' gbvxEBhE̕\͈͂擾܂B
        ''' </summary>
        ''' <param name="WindowName">EBhE</param>
        ''' <returns>EBhE\͈</returns>
        ''' <remarks></remarks>
        Public Shared Function GetWindowRect(ByVal WindowName As String) As Rectangle

            'EBhEnh擾
            Dim hw As IntPtr = cvGetWindowHandle(WindowName)

            '擾
            Dim rct As New APIRECT
            If GetWindowRect(hw, rct) = 0 Then
                Return New Rectangle(0, 0, 0, 0)
            End If

            '
            Return New Rectangle(rct.Left, rct.Top, rct.Right, rct.Bottom)

        End Function

        ''' <summary>
        ''' gbvxEBhE̍Wݒ肵܂B
        ''' </summary>
        ''' <param name="WindowName">EBhE</param>
        ''' <param name="x">ʒu</param>
        ''' <param name="y">cʒu</param>
        ''' <remarks></remarks>
        Public Shared Sub SetWindowLocate(ByVal WindowName As String, ByVal x As Integer, ByVal y As Integer)

            'mF
            If WindowName = "" Then Exit Sub

            'ݒ
            cvMoveWindow(WindowName, x, y)

        End Sub

#End Region

        '------------------------------------------------------
#Region "EBhE̐"

        ''' <summary>
        ''' zu\萔łB
        ''' </summary>
        ''' <remarks></remarks>
        Public Enum ArrangeType

            ''' <summary>EBhẺE</summary>
            Left = 0

            ''' <summary>EBhẺ</summary>
            Bottom = 1

        End Enum

        ''' <summary>
        ''' EBhEʒu𒲐܂B
        ''' </summary>
        ''' <param name="BaseWindowName">ƂȂEBhE̖</param>
        ''' <param name="TargetWindowName">ʒu𒲐EBhE̖</param>
        ''' <param name="Type">zu@</param>
        ''' <remarks></remarks>
        Public Shared Sub WindowArrange(ByVal BaseWindowName As String, ByVal TargetWindowName As String, ByVal Type As ArrangeType)

            '݂̈ʒuƃTCY擾
            Dim bw As Rectangle = GetWindowRect(BaseWindowName)
            Dim tw As Rectangle = GetWindowRect(TargetWindowName)

            'zu
            Select Case Type
                Case ArrangeType.Left   'Eɔzu
                    SetWindowLocate(TargetWindowName, bw.Right, bw.Top)

                Case ArrangeType.Bottom 'ɔzu
                    SetWindowLocate(TargetWindowName, bw.Left, bw.Bottom)

            End Select

        End Sub

        ''' <summary>
        ''' EBhEʒu𒲐܂B
        ''' </summary>
        ''' <param name="BaseWindowName">ƂȂEBhE̖</param>
        ''' <param name="Type">zu@</param>
        ''' <remarks></remarks>
        Public Sub Arrange(ByVal BaseWindowName As String, ByVal Type As ArrangeType)
            WindowArrange(BaseWindowName, mWindowName, Type)
        End Sub

#End Region

        '------------------------------------------------------
#Region "\"

        ''' <summary>
        ''' C[W\܂B
        ''' </summary>
        ''' <param name="WindowName">EBhE</param>
        ''' <param name="Image">C[W</param>
        ''' <remarks></remarks>
        Public Shared Sub Show(ByVal WindowName As String, ByVal Image As IntPtr)
            cvShowImage(WindowName, Image)
        End Sub

        ''' <summary>
        ''' C[W\܂B
        ''' </summary>
        ''' <param name="ImagePtr">C[W</param>
        ''' <remarks></remarks>
        Public Sub Show(ByVal ImagePtr As IntPtr)
            Show(Me.Name, ImagePtr)
        End Sub

#End Region


    End Class

#End Region

End Module
